Update to 2.1.x development version
[glibc.git] / elf / ldd.sh.in
blob0f3ed2e729da6abb8d34929823fb2b99b91cee9a
1 #! /bin/sh
3 # Copyright (C) 1996, 1997 Free Software Foundation, Inc.
4 # This file is part of the GNU C Library.
6 # The GNU C Library is free software; you can redistribute it and/or
7 # modify it under the terms of the GNU Library General Public License as
8 # published by the Free Software Foundation; either version 2 of the
9 # License, or (at your option) any later version.
11 # The GNU C Library is distributed in the hope that it will be useful,
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
14 # Library General Public License for more details.
16 # You should have received a copy of the GNU Library General Public
17 # License along with the GNU C Library; see the file COPYING.LIB. If not,
18 # write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
19 # Boston, MA 02111-1307, USA.
22 # This is the `ldd' command, which lists what shared libraries are
23 # used by given dynamically-linked executables. It works by invoking the
24 # run-time dynamic linker as a command and setting the environment
25 # variable LD_TRACE_LOADED_OBJECTS to a non-empty value.
27 RTLD=@RTLD@
28 warn=
29 bind_now=
31 while test $# -gt 0; do
32 case "$1" in
33 --v | --ve | --ver | --vers | --versi | --versio | --version)
34 echo 'ldd (GNU libc) @VERSION@
35 Copyright (C) 1996, 1997 Free Software Foundation, Inc.
36 This is free software; see the source for copying conditions. There is NO
37 warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.'
38 exit 0 ;;
39 --h | --he | --hel | --help)
40 echo "ldd [OPTION]... FILE...
41 --help print this help and exit
42 --version print version information and exit
43 -d, --data-relocs process data relocations
44 -r, --function-relocs process data and function relocations
45 Report bugs using the \`glibcbug' script to <bugs@gnu.ai.mit.edu>."
46 exit 0 ;;
47 -d | --d | --da | --dat | --data | --data- | --data-r | --data-re | \
48 --data-rel | --data-relo | --data-reloc | --data-relocs)
49 warn=yes
50 shift ;;
51 -r | --f | --fu | --fun | --func | --funct | --functi | --functio | \
52 --function | --function- | --function-r | --function-re | --function-rel | \
53 --function-relo | --function-reloc | --function-relocs)
54 warn=yes
55 bind_now=yes
56 shift ;;
57 --) # Stop option processing.
58 shift; break ;;
59 -*)
60 echo >&2 "\
61 ldd: unrecognized option \`$1'
62 Try \`ldd --help' for more information."
63 exit 1 ;;
65 break ;;
66 esac
67 done
69 case $# in
71 echo >&2 "\
72 ldd: missing file arguments
73 Try \`ldd --help' for more information."
74 exit 1 ;;
76 # We don't list the file name when there is only one.
77 case "$1" in
78 /*) file="$1" ;;
79 *) file="./$1" ;;
80 esac
81 if test ! -f "$file"; then
82 echo "ldd: ${file}: no such file"
83 exit 1
84 else
85 if test -r "$file"; then
86 test -x "$file" ||
87 echo "ldd: warning: you do not have execution permission for \`$file'"
88 if ${RTLD} --verify "$file"; then
89 LD_TRACE_LOADED_OBJECTS=1 LD_WARN=$warn LD_BIND_NOW=$bind_now \
90 exec ${RTLD} "$file" || exit 1
91 else
92 echo ' not a dynamic executable'
93 exit 1
95 else
96 echo "ldd: error: you do not have read permission for \`$file'"
97 exit 1
100 exit ;;
102 set -e # Bail out immediately if ${RTLD} loses on any argument.
103 result=0
104 for file; do
105 echo "${file}:"
106 case "$file" in
107 /*) : ;;
108 *) file="./$file" ;;
109 esac
110 if test ! -f "$file"; then
111 echo "ldd: ${file}: no such file"
112 result=1
113 else
114 if test -r "$file"; then
115 test -x "$file" || echo "\
116 ldd: warning: you do not have execution permission for \`$file'"
117 if ${RTLD} --verify "$file"; then
118 LD_TRACE_LOADED_OBJECTS=1 LD_WARN=$warn LD_BIND_NOW=$bind_now \
119 ${RTLD} "$file" || result=1
120 else
121 echo ' not a dynamic executable'
122 result=1
124 else
125 echo "ldd: error: you do not have read permission for \`$file'"
126 result=1
129 done
130 esac
132 exit $result